<template>
  <div
    class="scrollto"
    :class="{'_active': active }"
    @click="scroll">
    <div
      class="scrollto__arrow"
      :class="{'_down': scrollDown }">
      <img
        svg-inline
        src="~/assets/svg/arrow/up-bold.svg"
        alt="">
    </div>
  </div>
</template>
<script>
export default {
  props: {
    isFixed: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      active: false,
      scrollDown: false,
      savedPosition: null,
      currentPosition: null,
    };
  },
  beforeMount() {
    document.addEventListener('scroll', this.setActive);
  },
  destroyed() {
    document.removeEventListener('scroll', this.setActive);
  },
  methods: {
    scroll() {
      if (this.scrollDown) {
        window.scrollTo(0, this.savedPosition - 112);
      } else {
        this.savedPosition = document.documentElement.scrollTop || document.body.scrollTop;
        window.scrollTo(0, 0);
      }
      this.scrollDown = !this.scrollDown;
    },
    setActive() {
      this.currentPosition = document.documentElement.scrollTop || document.body.scrollTop;
      if (this.scrollDown && this.currentPosition < 50) {
        this.active = true;
      } else if (this.scrollDown && this.currentPosition >= 50) {
        this.scrollDown = false;
      } else {
        this.active = this.currentPosition > 236;
      }
    },
  },
};
</script>
<style scoped lang="scss">
  .scrollto {
    position: absolute;
    width: 2.75rem;
    top: 0;
    bottom: 0;
    right: 0;
    z-index: 100;
    background-color: rgba(228, 235, 246, 0.2);
    cursor: pointer;
    display: none;

    &:hover {
      background-color: rgba(228, 235, 246, 0.5);
      .scrollto__arrow {
        border: 1px solid #4272a4;
      }
    }

    &._active {
      display: block;
    }

    &__arrow {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      position: sticky;
      position: -webkit-sticky;
      width: 1.75rem;
      height: 1.75rem;
      margin: 1rem auto;
      top: 90vh;
      border: 1px solid #c5d1d9;
      border-radius: 50%;
      .svg {
        margin: auto;
        width: 0.75rem;
        fill: #4272a4;
        transform: rotate(0);
      }

      &._down {
        top: 0;
        .svg {
          transform: rotate(180deg);
        }
      }
    }
  }
</style>
